//Datei: DS1821IO.C
// Hauptprogramm
// Temperatur messen mit PIC16F84
// und DS1821
//
// Holger Klabunde
// Copyright 2000
// 22.04.2001
// Compiler PICC Lite

#include "prozess.h"      /* Der verwendete Prozessor */
#include "ds1821.h"
#include "protos.h"

unsigned char mask,count; //fr die Schleifen unten

void PollStatus()
{
 do
  {
   MasterReset();
   SendByte(READSTATUS);
   ReadByte(8);
   if((tempbuf&0x80)>0) return; //Temp gemessen !
  }while(1);
}

//Sendet die Master Reset Sequenz
//Und fragt Presence ab
void MasterReset()
{
 DQ=0; //Fr Master Reset DQ=0;
 Delay100us(6); //Fr min. 480us     
 DQ=1; //Leitung freigeben
 Delay10us();
 while(DQ==1); //Warten bis DS sich meldet
 while(DQ==0); //Presence Pulse abwarten
 Delay100us(6); //Fr min. 480us     
}

void SendByte(unsigned char by)
{
 mask=0x01;

 for(count=0; count<8; count++) //8Bits senden
  {
   if((mask&by)==0) //Ein 0-Bit
    {
     DQ=0; //Jetzt min 60us warten
     Delay10us(); Delay10us();
     Delay10us(); Delay10us();
     Delay10us(); Delay10us();
     Delay10us(); Delay10us();
     Delay10us();
    }
   else             //Ein 1-Bit
    {
     DQ=0;
     NOP(); NOP();      //Kurz warten
    } 

   DQ=1;
   Delay100us(1);
   mask<<=1; //Nchstes Bit
  }
}

void ReadByte(unsigned char bi)
{
 unsigned char buf;
 
 mask=0x01;
 buf=0;
 
 for(count=0; count<8; count++) //bi Bits empfangen
  {
   DQ=0; //Flanke fr DS
   NOP(); NOP(); //Kurz warten
   DQ=1; //Leitung freigeben

   NOP(); NOP(); NOP(); NOP(); //Kurz warten
   NOP(); NOP(); NOP(); NOP(); //Kurz warten
   
   if(DQ==1) buf|=mask;
   else while(DQ==0);  //Lange 0-Phase vom DS abwarten
   Delay100us(1);
   
   mask<<=1; //Nchstes Bit
  }

 tempbuf=buf;

 if(bi==9)
  {
   DQ=0; //Flanke fr DS
   NOP(); NOP(); //Kurz warten
   DQ=1; //Leitung freigeben

   NOP(); NOP(); NOP(); NOP(); //Kurz warten
   NOP(); NOP(); NOP(); NOP(); //Kurz warten

   if(DQ==1) tempbuf+=0x100; //9tes Bit lesen
   else while(DQ==0);  //Lange 0-Phase vom DS abwarten
  }
 Delay100us(6);
}
